#!/usr/bin/perl
# Copyright (C) 2008, The Perl Foundation.
# $Id$

use strict;
use warnings;

my @files = @ARGV;

print <<"END_SETTING";
# This file automatically generated by $0.
no Main;

END_SETTING

foreach my $file (@files) {
    print "# From $file\n\n";
    open(my $fh, "< $file") or die $!;
    print join('', <$fh>);
    close $fh;
}

my @classes = ('Any');
foreach my $file (@files) {
    next unless $file =~ /setting((?:[\/\\]\w+)+)\.pm$/;
    my $full_modname = substr($1, 1);
    push @classes, $full_modname;
}

print <<"END_SETTING";
# Need to use all built-in classes, to import their exports.
END_SETTING
s/\\/\//g for @classes;
print join('', map {
    my $colon_form = $_;
    $colon_form =~ s/[\/\\]/::/g;
    "BEGIN { \%*INC<$_> = 1 };\nuse $colon_form;\n" } @classes);

# Why yes, "OMFG" is a correct response to this hack. We need to make sure
# that we set up %*INC properly for the pre-compiled case, and can't use
# BEGIN blocks to preserve those changes for now.
print <<"END_SETTING";
Q:PIR {
    .return (1)
.end
.sub '' :load :init
};
END_SETTING
print join('', map { "\%*INC<$_> = 1;\n" } @classes);
